# 1 "src/arch/riscv/boot.c"
# 1 "<built-in>" 1
# 1 "<built-in>" 3
# 381 "<built-in>" 3
# 1 "<command line>" 1
# 1 "<built-in>" 2
# 1 "./src/include/kconfig.h" 1



# 1 "/cb-build/coreboot_scanbuild.0/EMULATION_SPIKE_RISCV/config.h" 1
# 5 "./src/include/kconfig.h" 2
# 2 "<built-in>" 2
# 1 "./src/include/rules.h" 1
# 3 "<built-in>" 2
# 1 "./src/commonlib/bsd/include/commonlib/bsd/compiler.h" 1
# 4 "<built-in>" 2
# 1 "src/arch/riscv/boot.c" 2


# 1 "src/include/program_loading.h" 1




# 1 "src/include/bootmem.h" 1





# 1 "src/include/boot/coreboot_tables.h" 1





# 1 "src/commonlib/include/commonlib/coreboot_tables.h" 1





# 1 "src/include/stdint.h" 1






typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef signed short int16_t;
typedef unsigned short uint16_t;

typedef signed int int32_t;
typedef unsigned int uint32_t;

typedef signed long long int64_t;
typedef unsigned long long uint64_t;


typedef signed long intptr_t;
typedef unsigned long uintptr_t;


_Static_assert(sizeof(int8_t) == 1, "Size of int8_t is incorrect");
_Static_assert(sizeof(uint8_t) == 1, "Size of uint8_t is incorrect");

_Static_assert(sizeof(int16_t) == 2, "Size of int16_t is incorrect");
_Static_assert(sizeof(uint16_t) == 2, "Size of uint16_t is incorrect");

_Static_assert(sizeof(int32_t) == 4, "Size of int32_t is incorrect");
_Static_assert(sizeof(uint32_t) == 4, "Size of uint32_t is incorrect");

_Static_assert(sizeof(int64_t) == 8, "Size of int64_t is incorrect");
_Static_assert(sizeof(uint64_t) == 8, "Size of uint64_t is incorrect");

_Static_assert(sizeof(intptr_t) == sizeof(void *), "Size of intptr_t is incorrect");
_Static_assert(sizeof(uintptr_t) == sizeof(void *), "Size of uintptr_t is incorrect");


typedef int64_t intmax_t;
typedef uint64_t uintmax_t;


typedef int8_t s8;
typedef uint8_t u8;

typedef int16_t s16;
typedef uint16_t u16;

typedef int32_t s32;
typedef uint32_t u32;

typedef int64_t s64;
typedef uint64_t u64;
# 7 "src/commonlib/include/commonlib/coreboot_tables.h" 2
# 36 "src/commonlib/include/commonlib/coreboot_tables.h"
enum {
 LB_TAG_UNUSED = 0x0000,
 LB_TAG_MEMORY = 0x0001,
 LB_TAG_HWRPB = 0x0002,
 LB_TAG_MAINBOARD = 0x0003,
 LB_TAG_VERSION = 0x0004,
 LB_TAG_EXTRA_VERSION = 0x0005,
 LB_TAG_BUILD = 0x0006,
 LB_TAG_COMPILE_TIME = 0x0007,
 LB_TAG_COMPILE_BY = 0x0008,
 LB_TAG_COMPILE_HOST = 0x0009,
 LB_TAG_COMPILE_DOMAIN = 0x000a,
 LB_TAG_COMPILER = 0x000b,
 LB_TAG_LINKER = 0x000c,
 LB_TAG_ASSEMBLER = 0x000d,
 LB_TAG_SERIAL = 0x000f,
 LB_TAG_CONSOLE = 0x0010,
 LB_TAG_FORWARD = 0x0011,
 LB_TAG_FRAMEBUFFER = 0x0012,
 LB_TAG_GPIO = 0x0013,
 LB_TAG_TIMESTAMPS = 0x0016,
 LB_TAG_CBMEM_CONSOLE = 0x0017,
 LB_TAG_MRC_CACHE = 0x0018,
 LB_TAG_VBNV = 0x0019,
 LB_TAG_VBOOT_HANDOFF = 0x0020,
 LB_TAG_X86_ROM_MTRR = 0x0021,
 LB_TAG_DMA = 0x0022,
 LB_TAG_RAM_OOPS = 0x0023,
 LB_TAG_ACPI_GNVS = 0x0024,
 LB_TAG_BOARD_ID = 0x0025,
 LB_TAG_VERSION_TIMESTAMP = 0x0026,
 LB_TAG_WIFI_CALIBRATION = 0x0027,
 LB_TAG_RAM_CODE = 0x0028,
 LB_TAG_SPI_FLASH = 0x0029,
 LB_TAG_SERIALNO = 0x002a,
 LB_TAG_MTC = 0x002b,
 LB_TAG_VPD = 0x002c,
 LB_TAG_SKU_ID = 0x002d,
 LB_TAG_BOOT_MEDIA_PARAMS = 0x0030,
 LB_TAG_CBMEM_ENTRY = 0x0031,
 LB_TAG_TSC_INFO = 0x0032,
 LB_TAG_MAC_ADDRS = 0x0033,
 LB_TAG_VBOOT_WORKBUF = 0x0034,
 LB_TAG_MMC_INFO = 0x0035,
 LB_TAG_TPM_CB_LOG = 0x0036,
 LB_TAG_FMAP = 0x0037,
 LB_TAG_PLATFORM_BLOB_VERSION = 0x0038,
 LB_TAG_SMMSTOREV2 = 0x0039,
 LB_TAG_TPM_PPI_HANDOFF = 0x003a,
 LB_TAG_BOARD_CONFIG = 0x0040,
 LB_TAG_ACPI_CNVS = 0x0041,
 LB_TAG_TYPE_C_INFO = 0x0042,
 LB_TAG_ACPI_RSDP = 0x0043,
 LB_TAG_PCIE = 0x0044,

 LB_TAG_CMOS_OPTION_TABLE = 0x00c8,
 LB_TAG_OPTION = 0x00c9,
 LB_TAG_OPTION_ENUM = 0x00ca,
 LB_TAG_OPTION_DEFAULTS = 0x00cb,
 LB_TAG_OPTION_CHECKSUM = 0x00cc,
};
# 110 "src/commonlib/include/commonlib/coreboot_tables.h"
typedef __attribute__((__aligned__(4))) uint64_t lb_uint64_t;

struct lb_header {
 uint8_t signature[4];
 uint32_t header_bytes;
 uint32_t header_checksum;
 uint32_t table_bytes;
 uint32_t table_checksum;
 uint32_t table_entries;
};







struct lb_record {
 uint32_t tag;
 uint32_t size;
};

struct lb_memory_range {
 lb_uint64_t start;
 lb_uint64_t size;
 uint32_t type;
# 144 "src/commonlib/include/commonlib/coreboot_tables.h"
};

struct lb_memory {
 uint32_t tag;
 uint32_t size;
 struct lb_memory_range map[];
};

struct lb_pcie {
 uint32_t tag;
 uint32_t size;
 lb_uint64_t ctrl_base;
};
_Static_assert(_Alignof(struct lb_pcie) == 4,
        "lb_uint64_t alignment doesn't work as expected for struct lb_pcie!");

struct lb_hwrpb {
 uint32_t tag;
 uint32_t size;
 lb_uint64_t hwrpb;
};

struct lb_mainboard {
 uint32_t tag;
 uint32_t size;
 uint8_t vendor_idx;
 uint8_t part_number_idx;
 uint8_t strings[];
};

struct lb_string {
 uint32_t tag;
 uint32_t size;
 uint8_t string[];
};

struct lb_timestamp {
 uint32_t tag;
 uint32_t size;
 uint32_t timestamp;
};



struct lb_serial {
 uint32_t tag;
 uint32_t size;


 uint32_t type;
 uint32_t baseaddr;
 uint32_t baud;
 uint32_t regwidth;






 uint32_t input_hertz;
};

struct lb_console {
 uint32_t tag;
 uint32_t size;
 uint16_t type;
 uint8_t pad[2];
};
# 221 "src/commonlib/include/commonlib/coreboot_tables.h"
struct lb_forward {
 uint32_t tag;
 uint32_t size;
 lb_uint64_t forward;
};
# 271 "src/commonlib/include/commonlib/coreboot_tables.h"
enum lb_fb_orientation {
 LB_FB_ORIENTATION_NORMAL = 0,
 LB_FB_ORIENTATION_BOTTOM_UP = 1,
 LB_FB_ORIENTATION_LEFT_UP = 2,
 LB_FB_ORIENTATION_RIGHT_UP = 3,
};

struct lb_framebuffer_flags {
 uint8_t has_external_display : 1;
 uint8_t reserved : 7;
};

struct lb_framebuffer {
 uint32_t tag;
 uint32_t size;

 lb_uint64_t physical_address;
 uint32_t x_resolution;
 uint32_t y_resolution;
 uint32_t bytes_per_line;
 uint8_t bits_per_pixel;
 uint8_t red_mask_pos;
 uint8_t red_mask_size;
 uint8_t green_mask_pos;
 uint8_t green_mask_size;
 uint8_t blue_mask_pos;
 uint8_t blue_mask_size;
 uint8_t reserved_mask_pos;
 uint8_t reserved_mask_size;
 uint8_t orientation;
 struct lb_framebuffer_flags flags;
 uint8_t pad;
};

struct lb_gpio {
 uint32_t port;
 uint32_t polarity;


 uint32_t value;

 uint8_t name[16];
};

struct lb_gpios {
 uint32_t tag;
 uint32_t size;

 uint32_t count;
 struct lb_gpio gpios[];
};

struct lb_range {
 uint32_t tag;
 uint32_t size;

 lb_uint64_t range_start;
 uint32_t range_size;
};

void lb_ramoops(struct lb_header *header);

struct lb_cbmem_ref {
 uint32_t tag;
 uint32_t size;

 lb_uint64_t cbmem_addr;
};

struct lb_x86_rom_mtrr {
 uint32_t tag;
 uint32_t size;

 uint32_t index;
};


struct flash_mmap_window {
 uint32_t flash_base;
 uint32_t host_base;
 uint32_t size;
};

struct lb_spi_flash {
 uint32_t tag;
 uint32_t size;
 uint32_t flash_size;
 uint32_t sector_size;
 uint32_t erase_cmd;





 uint32_t mmap_count;
 struct flash_mmap_window mmap_table[];
};

struct lb_boot_media_params {
 uint32_t tag;
 uint32_t size;

 lb_uint64_t fmap_offset;
 lb_uint64_t cbfs_offset;
 lb_uint64_t cbfs_size;
 lb_uint64_t boot_media_size;
};




struct lb_cbmem_entry {
 uint32_t tag;
 uint32_t size;

 lb_uint64_t address;
 uint32_t entry_size;
 uint32_t id;
};

struct lb_tsc_info {
 uint32_t tag;
 uint32_t size;

 uint32_t freq_khz;
};

struct mac_address {
 uint8_t mac_addr[6];
 uint8_t pad[2];
};

struct lb_mmc_info {
 uint32_t tag;
 uint32_t size;
# 414 "src/commonlib/include/commonlib/coreboot_tables.h"
 int32_t early_cmd1_status;
};







enum type_c_orientation {

 TYPEC_ORIENTATION_NONE,

 TYPEC_ORIENTATION_NORMAL,

 TYPEC_ORIENTATION_REVERSE,
};

struct type_c_port_info {
 uint8_t usb2_port_number;
 uint8_t usb3_port_number;
 uint8_t sbu_orientation;
 uint8_t data_orientation;
};

struct type_c_info {
 uint32_t port_count;
 struct type_c_port_info port_info[];
};

struct lb_macs {
 uint32_t tag;
 uint32_t size;
 uint32_t count;
 struct mac_address mac_addrs[];
};

struct lb_board_config {
 uint32_t tag;
 uint32_t size;

 lb_uint64_t fw_config;
 uint32_t board_id;
 uint32_t ram_code;
 uint32_t sku_id;
};





struct cmos_option_table {
 uint32_t tag;
 uint32_t size;
 uint32_t header_length;
};
# 478 "src/commonlib/include/commonlib/coreboot_tables.h"
struct cmos_entries {
 uint32_t tag;
 uint32_t size;
 uint32_t bit;
 uint32_t length;
 uint32_t config;
 uint32_t config_id;

 uint8_t name[32];

};





struct cmos_enums {
 uint32_t tag;
 uint32_t size;
 uint32_t config_id;
 uint32_t value;

 uint8_t text[32];

};




struct cmos_defaults {
 uint32_t tag;
 uint32_t size;
 uint32_t name_length;
 uint8_t name[32];

 uint8_t default_set[256];
};

struct cmos_checksum {
 uint32_t tag;
 uint32_t size;



 uint32_t range_start;
 uint32_t range_end;
 uint32_t location;
 uint32_t type;


};





struct lb_smmstorev2 {
 uint32_t tag;
 uint32_t size;
 uint32_t num_blocks;
 uint32_t block_size;
 uint32_t mmap_addr;
 uint32_t com_buffer;
 uint32_t com_buffer_size;
 uint8_t apm_cmd;
 uint8_t unused[3];
};

enum lb_tpm_ppi_tpm_version {
 LB_TPM_VERSION_UNSPEC = 0,
 LB_TPM_VERSION_TPM_VERSION_1_2,
 LB_TPM_VERSION_TPM_VERSION_2,
};
# 562 "src/commonlib/include/commonlib/coreboot_tables.h"
struct lb_tpm_physical_presence {
 uint32_t tag;
 uint32_t size;
 uint32_t ppi_address;
 uint8_t tpm_version;
 uint8_t ppi_version;
 uint8_t pad[2];
};





struct lb_acpi_rsdp {
 uint32_t tag;
 uint32_t size;
 lb_uint64_t rsdp_pointer;
};
# 7 "src/include/boot/coreboot_tables.h" 2
# 1 "src/include/stddef.h" 1





# 1 "src/commonlib/include/commonlib/helpers.h" 1
# 10 "src/commonlib/include/commonlib/helpers.h"
# 1 "src/commonlib/bsd/include/commonlib/bsd/helpers.h" 1







# 1 "src/include/stddef.h" 1
# 9 "src/commonlib/bsd/include/commonlib/bsd/helpers.h" 2
# 11 "src/commonlib/include/commonlib/helpers.h" 2
# 7 "src/include/stddef.h" 2

typedef long int ptrdiff_t;
typedef long unsigned int size_t;






typedef long signed int ssize_t;


typedef int wchar_t;
typedef unsigned int wint_t;
# 42 "src/include/stddef.h"
extern char zeroptr[];
# 8 "src/include/boot/coreboot_tables.h" 2








size_t write_coreboot_forwarding_table(uintptr_t entry, uintptr_t target);

void fill_lb_gpios(struct lb_gpios *gpios);
void lb_add_gpios(struct lb_gpios *gpios, const struct lb_gpio *gpio_table,
    size_t count);

enum cb_err fill_lb_serial(struct lb_serial *serial);
void lb_add_console(uint16_t consoletype, void *data);

enum cb_err fill_lb_pcie(struct lb_pcie *pcie);


void lb_board(struct lb_header *header);



int fill_lb_framebuffer(struct lb_framebuffer *framebuffer);


void lb_arch_add_records(struct lb_header *header);





void lb_table_add_macs_from_vpd(struct lb_header *header);

void lb_table_add_serialno_from_vpd(struct lb_header *header);

struct lb_record *lb_new_record(struct lb_header *header);


void lb_table_add_vbnv_cmos(struct lb_header *header);
# 7 "src/include/bootmem.h" 2
# 1 "src/include/memrange.h" 1




# 1 "src/include/device/resource.h" 1
# 44 "src/include/device/resource.h"
typedef u64 resource_t;
struct resource {
 resource_t base;
 resource_t size;
 resource_t limit;
               struct resource *next;
 unsigned long flags;
 unsigned long index;
 unsigned char align;
 unsigned char gran;

};
# 66 "src/include/device/resource.h"
struct device;
struct bus;
void compact_resources(struct device *dev);
struct resource *probe_resource(const struct device *dev, unsigned int index);
struct resource *new_resource(struct device *dev, unsigned int index);
struct resource *find_resource(const struct device *dev, unsigned int index);
resource_t resource_end(const struct resource *resource);
resource_t resource_max(const struct resource *resource);
void report_resource_stored(struct device *dev, const struct resource *resource,
       const char *comment);

typedef void (*resource_search_t)(void *gp, struct device *dev, struct resource *res);

void search_bus_resources(struct bus *bus, unsigned long type_mask, unsigned long type,
     resource_search_t search, void *gp);

void search_global_resources(unsigned long type_mask, unsigned long type,
        resource_search_t search, void *gp);


const char *resource_type(const struct resource *resource);

static inline void *res2mmio(const struct resource *res, unsigned long offset,
        unsigned long mask)
{
 return (void *)(uintptr_t)((res->base + offset) & ~mask);
}

void log_resource(const char *type, const struct device *dev, const struct resource *res,
    const char *srcfile, const int line);
# 116 "src/include/device/resource.h"
const struct device *largest_resource(struct bus *bus, struct resource **result_res,
          unsigned long type_mask, unsigned long type);


void allocate_resources(const struct device *root);
# 6 "src/include/memrange.h" 2
# 1 "src/include/stdbool.h" 1





typedef _Bool bool;
# 7 "src/include/memrange.h" 2




struct memranges {
 struct range_entry *entries;


 struct range_entry *free_list;

 unsigned char align;
};





struct range_entry {
 resource_t begin;
 resource_t end;
 unsigned long tag;
 struct range_entry *next;
};



static inline void range_entry_init(struct range_entry *re,
    resource_t incl_begin, resource_t excl_end,
    unsigned long tag)
{
 re->begin = incl_begin;
 re->end = excl_end - 1;
 re->tag = tag;
 re->next = ((void *)0);
}


static inline resource_t range_entry_base(const struct range_entry *r)
{
 return r->begin;
}


static inline resource_t range_entry_end(const struct range_entry *r)
{
 return r->end + 1;
}


static inline resource_t range_entry_size(const struct range_entry *r)
{
 return r->end - r->begin + 1;
}

static inline unsigned long range_entry_tag(const struct range_entry *r)
{
 return r->tag;
}

static inline void range_entry_update_tag(struct range_entry *r,
       unsigned long new_tag)
{
 r->tag = new_tag;
}

static inline bool memranges_is_empty(const struct memranges *ranges)
{
 return ranges->entries == ((void *)0);
}
# 88 "src/include/memrange.h"
void memranges_init_empty_with_alignment(struct memranges *ranges,
      struct range_entry *free,
      size_t num_free, unsigned char align);





void memranges_init_with_alignment(struct memranges *ranges,
      unsigned long mask, unsigned long match,
      unsigned long tag, unsigned char align);
# 112 "src/include/memrange.h"
void memranges_clone(struct memranges *newranges, struct memranges *oldranges);


void memranges_teardown(struct memranges *ranges);






void memranges_add_resources(struct memranges *ranges,
        unsigned long mask, unsigned long match,
        unsigned long tag);
# 133 "src/include/memrange.h"
typedef int (*memrange_filter_t)(struct device *dev, struct resource *res);
void memranges_add_resources_filter(struct memranges *ranges,
        unsigned long mask, unsigned long match,
        unsigned long tag,
        memrange_filter_t filter);



void memranges_fill_holes_up_to(struct memranges *ranges,
    resource_t limit, unsigned long tag);



void memranges_create_hole(struct memranges *ranges,
      resource_t base, resource_t size);




void memranges_insert(struct memranges *ranges,
        resource_t base, resource_t size, unsigned long tag);


void memranges_update_tag(struct memranges *ranges, unsigned long old_tag,
     unsigned long new_tag);


struct range_entry *memranges_next_entry(struct memranges *ranges,
      const struct range_entry *r);
# 173 "src/include/memrange.h"
bool memranges_steal(struct memranges *ranges, resource_t limit, resource_t size,
   unsigned char align, unsigned long tag, resource_t *stolen_base,
   bool from_top);
# 8 "src/include/bootmem.h" 2
# 1 "src/include/types.h" 1







# 1 "src/commonlib/bsd/include/commonlib/bsd/cb_err.h" 1
# 15 "src/commonlib/bsd/include/commonlib/bsd/cb_err.h"
enum cb_err {
 CB_SUCCESS = 0,
 CB_ERR = -1,
 CB_ERR_ARG = -2,
 CB_ERR_NOT_IMPLEMENTED = -3,


 CB_CMOS_OTABLE_DISABLED = -100,
 CB_CMOS_LAYOUT_NOT_FOUND = -101,
 CB_CMOS_OPTION_NOT_FOUND = -102,
 CB_CMOS_ACCESS_ERROR = -103,
 CB_CMOS_CHECKSUM_INVALID = -104,


 CB_KBD_CONTROLLER_FAILURE = -200,
 CB_KBD_INTERFACE_FAILURE = -201,


 CB_I2C_NO_DEVICE = -300,
 CB_I2C_BUSY = -301,
 CB_I2C_PROTOCOL_ERROR = -302,

 CB_I2C_TIMEOUT = -303,


 CB_CBFS_IO = -400,
 CB_CBFS_NOT_FOUND = -401,
 CB_CBFS_HASH_MISMATCH = -402,
 CB_CBFS_CACHE_FULL = -403,


 CB_EFI_FVH_INVALID = -500,
 CB_EFI_CHECKSUM_INVALID = -501,
 CB_EFI_VS_NOT_FORMATTED_INVALID = -502,
 CB_EFI_VS_CORRUPTED_INVALID = -503,
 CB_EFI_ACCESS_ERROR = -504,
 CB_EFI_STORE_FULL = -505,
 CB_EFI_OPTION_NOT_FOUND = -506,
 CB_EFI_BUFFER_TOO_SMALL = -507,
};
# 9 "src/include/types.h" 2
# 1 "src/include/limits.h" 1
# 10 "src/include/types.h" 2
# 9 "src/include/bootmem.h" 2
# 19 "src/include/bootmem.h"
enum bootmem_type {
 BM_MEM_INVALID = 0,

 BM_MEM_FIRST = 0x10000,
 BM_MEM_RAM,
 BM_MEM_RESERVED,
 BM_MEM_SOFT_RESERVED,
 BM_MEM_ACPI,
 BM_MEM_NVS,
 BM_MEM_UNUSABLE,
 BM_MEM_VENDOR_RSVD,
 BM_MEM_OPENSBI,
 BM_MEM_BL31,
 BM_MEM_TABLE,

 BM_MEM_OS_CUTOFF = BM_MEM_TABLE,
 BM_MEM_RAMSTAGE,
 BM_MEM_PAYLOAD,
 BM_MEM_LAST,
};
# 51 "src/include/bootmem.h"
void bootmem_write_memory_table(struct lb_memory *mem);



void bootmem_arch_add_ranges(void);


void bootmem_platform_add_ranges(void);


void bootmem_add_range(uint64_t start, uint64_t size,
         const enum bootmem_type tag);


void bootmem_dump_ranges(void);

typedef bool (*range_action_t)(const struct range_entry *r, void *arg);
# 78 "src/include/bootmem.h"
bool bootmem_walk_os_mem(range_action_t action, void *arg);
# 89 "src/include/bootmem.h"
bool bootmem_walk(range_action_t action, void *arg);




int bootmem_region_targets_type(uint64_t start, uint64_t size,
  enum bootmem_type dest_type);


void *bootmem_allocate_buffer(size_t size);
# 6 "src/include/program_loading.h" 2
# 1 "src/commonlib/bsd/include/commonlib/bsd/cbfs_serialized.h" 1






# 1 "3rdparty/vboot/firmware/include/vb2_sha.h" 1
# 11 "3rdparty/vboot/firmware/include/vb2_sha.h"
# 1 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h" 1
# 14 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
# 1 "3rdparty/vboot/firmware/include/../2lib/include/2crypto.h" 1
# 11 "3rdparty/vboot/firmware/include/../2lib/include/2crypto.h"
# 1 "3rdparty/vboot/firmware/include/../2lib/include/2sysincludes.h" 1
# 16 "3rdparty/vboot/firmware/include/../2lib/include/2sysincludes.h"
# 1 "src/include/ctype.h" 1





static inline int isspace(int c)
{
 switch (c) {
 case ' ': case '\f': case '\n':
 case '\r': case '\t': case '\v':
  return 1;
 default:
  return 0;
 }
}

static inline int isprint(int c)
{
 return c >= ' ' && c <= '~';
}

static inline int isdigit(int c)
{
 return (c >= '0' && c <= '9');
}

static inline int isxdigit(int c)
{
 return ((c >= '0' && c <= '9') ||
  (c >= 'a' && c <= 'f') ||
  (c >= 'A' && c <= 'F'));
}

static inline int isupper(int c)
{
 return (c >= 'A' && c <= 'Z');
}

static inline int islower(int c)
{
 return (c >= 'a' && c <= 'z');
}

static inline int toupper(int c)
{
 if (islower(c))
  c -= 'a'-'A';
 return c;
}

static inline int tolower(int c)
{
 if (isupper(c))
  c -= 'A'-'a';
 return c;
}
# 17 "3rdparty/vboot/firmware/include/../2lib/include/2sysincludes.h" 2
# 1 "src/include/inttypes.h" 1
# 18 "3rdparty/vboot/firmware/include/../2lib/include/2sysincludes.h" 2



# 1 "src/include/stdio.h" 1
# 13 "src/include/stdio.h"
int snprintf(char *buf, size_t size, const char *fmt, ...);
# 22 "3rdparty/vboot/firmware/include/../2lib/include/2sysincludes.h" 2
# 1 "src/include/stdlib.h" 1





# 1 "src/commonlib/bsd/include/commonlib/bsd/stdlib.h" 1






# 1 "src/include/string.h" 1





# 1 "src/include/stdarg.h" 1
# 16 "src/include/stdarg.h"
typedef __builtin_va_list va_list;

int vsnprintf(char *buf, size_t size, const char *fmt, va_list args);
# 7 "src/include/string.h" 2



void *memcpy(void *dest, const void *src, size_t n);
void *memmove(void *dest, const void *src, size_t n);
void *memset(void *s, int c, size_t n);
int memcmp(const void *s1, const void *s2, size_t n);
void *memchr(const void *s, int c, size_t n);
char *strdup(const char *s);
char *strconcat(const char *s1, const char *s2);
size_t strnlen(const char *src, size_t max);
size_t strlen(const char *src);
char *strchr(const char *s, int c);
char *strncpy(char *to, const char *from, int count);
char *strcpy(char *dst, const char *src);
int strcmp(const char *s1, const char *s2);
int strncmp(const char *s1, const char *s2, int maxlen);
int strspn(const char *str, const char *spn);
int strcspn(const char *str, const char *spn);
char *strstr(const char *haystack, const char *needle);
char *strtok_r(char *str, const char *delim, char **ptr);
char *strtok(char *str, const char *delim);
long atol(const char *str);
# 39 "src/include/string.h"
char *strrchr(const char *s, int c);






unsigned int skip_atoi(char **s);
# 8 "src/commonlib/bsd/include/commonlib/bsd/stdlib.h" 2


# 1 "src/include/console/console.h" 1





# 1 "src/commonlib/include/commonlib/console/post_codes.h" 1
# 7 "src/include/console/console.h" 2
# 1 "src/include/console/vtxprintf.h" 1







int vtxprintf(void (*tx_byte)(unsigned char byte, void *data),
 const char *fmt, va_list args, void *data);
# 8 "src/include/console/console.h" 2



# 1 "src/commonlib/include/commonlib/loglevel.h" 1
# 168 "src/commonlib/include/commonlib/loglevel.h"
static const char bios_log_prefix[8 + 1][5] = {

 [0] = "EMERG",
 [1] = "ALERT",
 [2] = "CRIT ",
 [3] = "ERROR",
 [4] = "WARN ",
 [5] = "NOTE ",
 [6] = "INFO ",
 [7] = "DEBUG",
 [8] = "SPEW ",
};
# 192 "src/commonlib/include/commonlib/loglevel.h"
static const char bios_log_escape[8 + 1][8] = {
 [0] = "1;4;5;7",
 [1] = "1;4;7",
 [2] = "1;7",
 [3] = "7",
 [4] = "1;4",
 [5] = "1",
 [6] = "0",
 [7] = "0",
 [8] = "0",
};
# 12 "src/include/console/console.h" 2




void post_code(u8 value);
void mainboard_post(u8 value);
void arch_post_code(u8 value);
void soc_post_code(uint8_t value);

void __attribute__((__noreturn__)) __attribute__((format(printf, 1, 2))) die(const char *fmt, ...);







void die_notify(void);
# 38 "src/include/console/console.h"
static inline int get_console_loglevel(void)
{
 return 7;
}
# 51 "src/include/console/console.h"
int get_log_level(void);
void console_init(void);
int console_log_level(int msg_level);

int printk(int msg_level, const char *fmt, ...) __attribute__((format(printf, 2, 3)));
int vprintk(int msg_level, const char *fmt, va_list args);

void do_putchar(unsigned char byte);



long console_time_get_and_reset(void);
void console_time_report(void);







enum { CONSOLE_LOG_NONE = 0, CONSOLE_LOG_FAST, CONSOLE_LOG_ALL };
# 11 "src/commonlib/bsd/include/commonlib/bsd/stdlib.h" 2





void __attribute__((__noreturn__)) abort(void);
void free(void *ptr);
void *malloc(size_t size);
void *calloc(size_t nitems, size_t size);
void *memalign(size_t align, size_t size);
int dma_coherent(const void *ptr);

static inline void *xmalloc_work(size_t size, const char *file, const char *func, int line)
{
 void *ret = malloc(size);
 if (!ret && size) {
  printk(3, "%s:%d %s(): Failed to malloc %zu bytes\n",
   file, line, func, size);
  abort();
 }
 return ret;
}


static inline void *xzalloc_work(size_t size, const char *file, const char *func, int line)
{
 void *ret = xmalloc_work(size, file, func, line);
 memset(ret, 0, size);
 return ret;
}


static inline void *xmemalign_work(size_t align, size_t size, const char *file,
      const char *func, int line)
{
 void *ret = memalign(align, size);
 if (!ret && size) {
  printk(3, "%s:%d %s(): "
    "Failed to memalign %zu bytes with %zu alignment.\n",
   file, line, func, size, align);
  abort();
 }
 return ret;
}
# 7 "src/include/stdlib.h" 2
# 23 "3rdparty/vboot/firmware/include/../2lib/include/2sysincludes.h" 2
# 12 "3rdparty/vboot/firmware/include/../2lib/include/2crypto.h" 2


enum vb2_crypto_algorithm {
 VB2_ALG_RSA1024_SHA1 = 0,
 VB2_ALG_RSA1024_SHA256 = 1,
 VB2_ALG_RSA1024_SHA512 = 2,
 VB2_ALG_RSA2048_SHA1 = 3,
 VB2_ALG_RSA2048_SHA256 = 4,
 VB2_ALG_RSA2048_SHA512 = 5,
 VB2_ALG_RSA4096_SHA1 = 6,
 VB2_ALG_RSA4096_SHA256 = 7,
 VB2_ALG_RSA4096_SHA512 = 8,
 VB2_ALG_RSA8192_SHA1 = 9,
 VB2_ALG_RSA8192_SHA256 = 10,
 VB2_ALG_RSA8192_SHA512 = 11,
 VB2_ALG_RSA2048_EXP3_SHA1 = 12,
 VB2_ALG_RSA2048_EXP3_SHA256 = 13,
 VB2_ALG_RSA2048_EXP3_SHA512 = 14,
 VB2_ALG_RSA3072_EXP3_SHA1 = 15,
 VB2_ALG_RSA3072_EXP3_SHA256 = 16,
 VB2_ALG_RSA3072_EXP3_SHA512 = 17,

 VB2_ALG_COUNT
};


enum vb2_signature_algorithm {

 VB2_SIG_INVALID = 0,





 VB2_SIG_NONE = 1,


 VB2_SIG_RSA1024 = 2,
 VB2_SIG_RSA2048 = 3,
 VB2_SIG_RSA4096 = 4,
 VB2_SIG_RSA8192 = 5,
 VB2_SIG_RSA2048_EXP3 = 6,
 VB2_SIG_RSA3072_EXP3 = 7,


 VB2_SIG_ALG_COUNT,
};


enum vb2_hash_algorithm {

 VB2_HASH_INVALID = 0,

 VB2_HASH_NONE = VB2_HASH_INVALID,


 VB2_HASH_SHA1 = 1,


 VB2_HASH_SHA256 = 2,
 VB2_HASH_SHA512 = 3,


 VB2_HASH_SHA224 = 4,
 VB2_HASH_SHA384 = 5,


 VB2_HASH_ALG_COUNT,
};


extern const char *vb2_sig_names[VB2_SIG_ALG_COUNT];
extern const char *vb2_hash_names[VB2_HASH_ALG_COUNT];
# 95 "3rdparty/vboot/firmware/include/../2lib/include/2crypto.h"
enum vb2_signature_algorithm vb2_crypto_to_signature(
     enum vb2_crypto_algorithm algorithm);
# 107 "3rdparty/vboot/firmware/include/../2lib/include/2crypto.h"
enum vb2_hash_algorithm vb2_crypto_to_hash(enum vb2_crypto_algorithm algorithm);







const char *vb2_get_sig_algorithm_name(enum vb2_signature_algorithm sig_alg);







const char *vb2_get_hash_algorithm_name(enum vb2_hash_algorithm alg);







const char *vb2_get_crypto_algorithm_name(enum vb2_crypto_algorithm alg);







const char *vb2_get_crypto_algorithm_file(enum vb2_crypto_algorithm alg);
# 15 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h" 2
# 1 "3rdparty/vboot/firmware/include/../2lib/include/2return_codes.h" 1
# 15 "3rdparty/vboot/firmware/include/../2lib/include/2return_codes.h"
typedef uint32_t vb2_error_t;







enum vb2_return_code {

 VB2_SUCCESS = 0,




 VB2_REQUEST = 0x1000,


 VB2_REQUEST_SHUTDOWN = 0x1001,


 VB2_REQUEST_REBOOT = 0x1002,


 VB2_REQUEST_REBOOT_EC_SWITCH_RW = 0x1003,


 VB2_REQUEST_REBOOT_EC_TO_RO = 0x1004,


 VB2_REQUEST_UI_CONTINUE = 0x1005,


 VB2_REQUEST_UI_EXIT = 0x1006,


 VB2_REQUEST_END = 0x5000,





 VB2_ERROR_BASE = 0x10000000,


 VB2_ERROR_UNKNOWN = VB2_ERROR_BASE + 1,


 VB2_ERROR_MOCK,




 VB2_ERROR_SHA = VB2_ERROR_BASE + 0x010000,


 VB2_ERROR_SHA_INIT_ALGORITHM,


 VB2_ERROR_SHA_EXTEND_ALGORITHM,


 VB2_ERROR_SHA_FINALIZE_ALGORITHM,


 VB2_ERROR_SHA_FINALIZE_DIGEST_SIZE,


 VB2_ERROR_SHA_MISMATCH,




 VB2_ERROR_RSA = VB2_ERROR_BASE + 0x020000,


 VB2_ERROR_RSA_PADDING,


 VB2_ERROR_RSA_PADDING_ALGORITHM,


 VB2_ERROR_RSA_VERIFY_PARAM,


 VB2_ERROR_RSA_VERIFY_ALGORITHM,


 VB2_ERROR_RSA_VERIFY_SIG_LEN,


 VB2_ERROR_RSA_VERIFY_WORKBUF,


 VB2_ERROR_RSA_VERIFY_DIGEST,


 VB2_ERROR_RSA_PADDING_SIZE,




 VB2_ERROR_NV = VB2_ERROR_BASE + 0x030000,


 VB2_ERROR_NV_HEADER,


 VB2_ERROR_NV_CRC,


 VB2_ERROR_NV_READ,


 VB2_ERROR_NV_WRITE,




 VB2_ERROR_SECDATA = VB2_ERROR_BASE + 0x040000,


 VB2_ERROR_SECDATA_FIRMWARE_CRC,


 VB2_ERROR_SECDATA_FIRMWARE_VERSION,



 VB2_ERROR_DEPRECATED_SECDATA_FIRMWARE_GET_PARAM,



 VB2_ERROR_DEPRECATED_SECDATA_FIRMWARE_SET_PARAM,



 VB2_ERROR_DEPRECATED_SECDATA_FIRMWARE_SET_FLAGS,



 VB2_ERROR_DEPRECATED_SECDATA_FIRMWARE_GET_UNINITIALIZED,



 VB2_ERROR_DEPRECATED_SECDATA_FIRMWARE_SET_UNINITIALIZED,


 VB2_ERROR_SECDATA_KERNEL_CRC,


 VB2_ERROR_SECDATA_KERNEL_VERSION,


 VB2_ERROR_SECDATA_KERNEL_UID,



 VB2_ERROR_DEPRECATED_SECDATA_KERNEL_GET_PARAM,



 VB2_ERROR_DEPRECATED_SECDATA_KERNEL_SET_PARAM,



 VB2_ERROR_DEPRECATED_SECDATA_KERNEL_SET_FLAGS,



 VB2_ERROR_DEPRECATED_SECDATA_KERNEL_GET_UNINITIALIZED,



 VB2_ERROR_DEPRECATED_SECDATA_KERNEL_SET_UNINITIALIZED,


 VB2_ERROR_SECDATA_FWMP_SIZE,


 VB2_ERROR_SECDATA_FWMP_INCOMPLETE,


 VB2_ERROR_SECDATA_FWMP_CRC,


 VB2_ERROR_SECDATA_FWMP_VERSION,


 VB2_ERROR_SECDATA_FIRMWARE_READ,


 VB2_ERROR_SECDATA_FIRMWARE_WRITE,


 VB2_ERROR_SECDATA_FIRMWARE_LOCK,


 VB2_ERROR_SECDATA_KERNEL_READ,


 VB2_ERROR_SECDATA_KERNEL_WRITE,


 VB2_ERROR_SECDATA_KERNEL_LOCK,


 VB2_ERROR_SECDATA_FWMP_READ,


 VB2_ERROR_SECDATA_KERNEL_BUFFER_SIZE,


 VB2_ERROR_SECDATA_KERNEL_INCOMPLETE,


 VB2_ERROR_SECDATA_KERNEL_STRUCT_SIZE,




 VB2_ERROR_COMMON = VB2_ERROR_BASE + 0x050000,


 VB2_ERROR_ALIGN_BIGGER_THAN_SIZE,


 VB2_ERROR_ALIGN_SIZE,


 VB2_ERROR_INSIDE_PARENT_WRAPS,


 VB2_ERROR_INSIDE_MEMBER_WRAPS,


 VB2_ERROR_INSIDE_MEMBER_OUTSIDE,


 VB2_ERROR_INSIDE_DATA_WRAPS,


 VB2_ERROR_INSIDE_DATA_OUTSIDE,


 VB2_ERROR_UNPACK_KEY_SIG_ALGORITHM,


 VB2_ERROR_UNPACK_KEY_SIZE,


 VB2_ERROR_UNPACK_KEY_ALIGN,


 VB2_ERROR_UNPACK_KEY_ARRAY_SIZE,


 VB2_ERROR_VDATA_ALGORITHM,


 VB2_ERROR_VDATA_SIG_SIZE,


 VB2_ERROR_VDATA_NOT_ENOUGH_DATA,


 VB2_ERROR_VDATA_WORKBUF_DIGEST,


 VB2_ERROR_VDATA_WORKBUF_HASHING,





 VB2_ERROR_VDATA_DIGEST_SIZE,


 VB2_ERROR_UNPACK_KEY_HASH_ALGORITHM,


 VB2_ERROR_INSIDE_DATA_OVERLAP,


 VB2_ERROR_UNPACK_KEY_STRUCT_VERSION,






 VB2_ERROR_COMMON_TOTAL_SIZE,
 VB2_ERROR_COMMON_FIXED_SIZE,
 VB2_ERROR_COMMON_DESC_SIZE,
 VB2_ERROR_COMMON_MEMBER_SIZE,





 VB2_ERROR_COMMON_TOTAL_UNALIGNED,
 VB2_ERROR_COMMON_FIXED_UNALIGNED,
 VB2_ERROR_COMMON_DESC_UNALIGNED,
 VB2_ERROR_COMMON_MEMBER_UNALIGNED,


 VB2_ERROR_COMMON_DESC_WRAPS,
 VB2_ERROR_COMMON_MEMBER_WRAPS,


 VB2_ERROR_COMMON_DESC_TERMINATOR,


 VB2_ERROR_COMMON_MEMBER_OVERLAP,


 VB2_ERROR_SIG_MAGIC,


 VB2_ERROR_SIG_VERSION,


 VB2_ERROR_SIG_HEADER_SIZE,


 VB2_ERROR_SIG_ALGORITHM,


 VB2_ERROR_SIG_SIZE,


 VB2_ERROR_VDATA_SIZE,


 VB2_ERROR_VDATA_VERIFY_DIGEST,


 VB2_ERROR_VDATA_ALGORITHM_MISMATCH,


 VB2_ERROR_UNPACK_KEY_MAGIC,


 VB2_ERROR_UNPACK_KEY_BUFFER,




 VB2_ERROR_KEYBLOCK = VB2_ERROR_BASE + 0x060000,


 VB2_ERROR_KEYBLOCK_TOO_SMALL_FOR_HEADER,


 VB2_ERROR_KEYBLOCK_MAGIC,


 VB2_ERROR_KEYBLOCK_HEADER_VERSION,


 VB2_ERROR_KEYBLOCK_SIZE,


 VB2_ERROR_KEYBLOCK_SIG_OUTSIDE,


 VB2_ERROR_KEYBLOCK_SIGNED_TOO_MUCH,


 VB2_ERROR_KEYBLOCK_SIGNED_TOO_LITTLE,


 VB2_ERROR_KEYBLOCK_SIG_INVALID,


 VB2_ERROR_KEYBLOCK_DATA_KEY_OUTSIDE,


 VB2_ERROR_KEYBLOCK_DATA_KEY_UNSIGNED,


 VB2_ERROR_KEYBLOCK_SIGNED_SIZE,


 VB2_ERROR_KEYBLOCK_SIG_ID,


 VB2_ERROR_KEYBLOCK_HASH_INVALID_IN_DEV_MODE,




 VB2_ERROR_PREAMBLE = VB2_ERROR_BASE + 0x070000,


 VB2_ERROR_PREAMBLE_TOO_SMALL_FOR_HEADER,


 VB2_ERROR_PREAMBLE_HEADER_VERSION,


 VB2_ERROR_PREAMBLE_HEADER_OLD,


 VB2_ERROR_PREAMBLE_SIZE,


 VB2_ERROR_PREAMBLE_SIG_OUTSIDE,


 VB2_ERROR_PREAMBLE_SIGNED_TOO_MUCH,


 VB2_ERROR_PREAMBLE_SIGNED_TOO_LITTLE,


 VB2_ERROR_PREAMBLE_SIG_INVALID,


 VB2_ERROR_PREAMBLE_BODY_SIG_OUTSIDE,


 VB2_ERROR_PREAMBLE_KERNEL_SUBKEY_OUTSIDE,


 VB2_ERROR_PREAMBLE_MAGIC,


 VB2_ERROR_PREAMBLE_HASH_SIGNED,


 VB2_ERROR_PREAMBLE_BOOTLOADER_OUTSIDE,


 VB2_ERROR_PREAMBLE_VMLINUZ_HEADER_OUTSIDE,




 VB2_ERROR_MISC = VB2_ERROR_BASE + 0x080000,


 VB2_ERROR_WORKBUF_SMALL = 0x10080001,


 VB2_ERROR_WORKBUF_ALIGN = 0x10080002,


 VB2_ERROR_GBB_WORKBUF = 0x10080003,


 VB2_ERROR_GBB_MAGIC = 0x10080004,


 VB2_ERROR_GBB_VERSION = 0x10080005,


 VB2_ERROR_GBB_TOO_OLD = 0x10080006,


 VB2_ERROR_GBB_HEADER_SIZE = 0x10080007,


 VB2_ERROR_FW_KEYBLOCK_WORKBUF_ROOT_KEY = 0x10080008,


 VB2_ERROR_FW_KEYBLOCK_WORKBUF_HEADER = 0x10080009,


 VB2_ERROR_FW_KEYBLOCK_WORKBUF = 0x1008000a,


 VB2_ERROR_FW_KEYBLOCK_VERSION_RANGE = 0x1008000b,


 VB2_ERROR_FW_KEYBLOCK_VERSION_ROLLBACK = 0x1008000c,


 VB2_ERROR_FW_PREAMBLE2_DATA_KEY = 0x1008000d,


 VB2_ERROR_FW_PREAMBLE2_WORKBUF_HEADER = 0x1008000e,


 VB2_ERROR_FW_PREAMBLE2_WORKBUF = 0x1008000f,


 VB2_ERROR_FW_PREAMBLE_VERSION_RANGE = 0x10080010,


 VB2_ERROR_FW_PREAMBLE_VERSION_ROLLBACK = 0x10080011,


 VB2_ERROR_READ_RESOURCE_OBJECT_BUF = 0x10080012,


 VB2_ERROR_KERNEL_KEYBLOCK_WORKBUF_HEADER = 0x10080013,


 VB2_ERROR_KERNEL_KEYBLOCK_WORKBUF = 0x10080014,


 VB2_ERROR_KERNEL_KEYBLOCK_VERSION_RANGE = 0x10080015,


 VB2_ERROR_KERNEL_KEYBLOCK_VERSION_ROLLBACK = 0x10080016,





 VB2_ERROR_KERNEL_KEYBLOCK_DEV_FLAG = 0x10080017,
 VB2_ERROR_KERNEL_KEYBLOCK_REC_FLAG = 0x10080018,


 VB2_ERROR_KERNEL_PREAMBLE2_DATA_KEY = 0x10080019,


 VB2_ERROR_KERNEL_PREAMBLE2_WORKBUF_HEADER = 0x1008001a,


 VB2_ERROR_KERNEL_PREAMBLE2_WORKBUF = 0x1008001b,


 VB2_ERROR_KERNEL_PREAMBLE_VERSION_RANGE = 0x1008001c,


 VB2_ERROR_KERNEL_PREAMBLE_VERSION_ROLLBACK = 0x1008001d,


 VB2_ERROR_API_GET_KERNEL_SIZE_PREAMBLE = 0x1008001e,



 VB2_ERROR_DEPRECATED_VBLOCK_KERNEL_SUBKEY = 0x1008001f,






 VB2_ERROR_DEPRECATED_VBLOCK_SELF_SIGNED = 0x10080020,



 VB2_ERROR_DEPRECATED_VBLOCK_KEYBLOCK_HASH = 0x10080021,



 VB2_ERROR_DEPRECATED_VBLOCK_KEYBLOCK = 0x10080022,


 VB2_ERROR_KERNEL_KEYBLOCK_DEV_KEY_HASH = 0x10080023,


 VB2_ERROR_LOAD_PARTITION_WORKBUF = 0x10080024,


 VB2_ERROR_LOAD_PARTITION_READ_VBLOCK = 0x10080025,


 VB2_ERROR_LOAD_PARTITION_VERIFY_VBLOCK = 0x10080026,


 VB2_ERROR_LOAD_PARTITION_BODY_OFFSET = 0x10080027,


 VB2_ERROR_LOAD_PARTITION_BODY_SIZE = 0x10080028,


 VB2_ERROR_LOAD_PARTITION_READ_BODY = 0x10080029,


 VB2_ERROR_LOAD_PARTITION_DATA_KEY = 0x1008002a,


 VB2_ERROR_LOAD_PARTITION_VERIFY_BODY = 0x1008002b,


 VB2_ERROR_EC_HASH_IMAGE = 0x1008002c,


 VB2_ERROR_EC_HASH_EXPECTED = 0x1008002d,


 VB2_ERROR_EC_HASH_SIZE = 0x1008002e,


 VB2_ERROR_SHARED_DATA_VERSION = 0x1008002f,


 VB2_ERROR_SHARED_DATA_MAGIC = 0x10080030,


 VB2_ERROR_GBB_INVALID = 0x10080031,


 VB2_ERROR_INVALID_PARAMETER = 0x10080032,


 VB2_ERROR_WORKBUF_INVALID = 0x10080033,


 VB2_ERROR_ESCAPE_NO_BOOT = 0x10080034,





 VB2_ERROR_KERNEL_KEYBLOCK_MINIOS_FLAG = 0x10080035,




 VB2_ERROR_API = VB2_ERROR_BASE + 0x090000,


 VB2_ERROR_API_INIT_HASH_TAG,


 VB2_ERROR_API_INIT_HASH_PREAMBLE,


 VB2_ERROR_API_INIT_HASH_WORKBUF,


 VB2_ERROR_API_INIT_HASH_DATA_KEY,


 VB2_ERROR_API_EXTEND_HASH_WORKBUF,


 VB2_ERROR_API_EXTEND_HASH_SIZE,


 VB2_ERROR_API_CHECK_HASH_PREAMBLE,


 VB2_ERROR_API_CHECK_HASH_WORKBUF,


 VB2_ERROR_API_CHECK_HASH_SIZE,


 VB2_ERROR_API_CHECK_HASH_WORKBUF_DIGEST,


 VB2_ERROR_API_CHECK_HASH_TAG,


 VB2_ERROR_API_CHECK_HASH_DATA_KEY,


 VB2_ERROR_API_CHECK_HASH_SIG_SIZE,


 VB2_ERROR_API_PHASE1_RECOVERY,


 VB2_ERROR_API_INIT_HASH_ID,


 VB2_ERROR_API_CHECK_HASH_SIG,


 VB2_ERROR_API_PCR_DIGEST,


 VB2_ERROR_API_PCR_DIGEST_BUF,



 VB2_ERROR_DEPRECATED_API_KPHASE1_WORKBUF_REC_KEY,


 VB2_ERROR_API_KPHASE1_PREAMBLE,


 VB2_ERROR_API_VERIFY_KDATA_SIZE,


 VB2_ERROR_API_VERIFY_KDATA_PREAMBLE,


 VB2_ERROR_API_VERIFY_KDATA_WORKBUF,


 VB2_ERROR_API_VERIFY_KDATA_KEY,


 VB2_ERROR_API_PHASE1_SECDATA_REBOOT,


 VB2_ERROR_API_CHECK_DIGEST_SIZE,


 VB2_ERROR_API_DISABLE_DEV_NOT_ALLOWED,


 VB2_ERROR_API_ENABLE_DEV_NOT_ALLOWED,


 VB2_ERROR_API_NEXT_SLOT_UNAVAILABLE,







 VB2_ERROR_EX = VB2_ERROR_BASE + 0x0a0000,



 VB2_ERROR_EX_DEPRECATED_READ_RESOURCE_UNIMPLEMENTED,


 VB2_ERROR_EX_READ_RESOURCE_INDEX,


 VB2_ERROR_EX_READ_RESOURCE_SIZE,


 VB2_ERROR_EX_TPM_CLEAR_OWNER,



 VB2_ERROR_DEPRECATED_EX_TPM_CLEAR_OWNER_UNIMPLEMENTED,


 VB2_ERROR_EX_HWCRYPTO_UNSUPPORTED,


 VB2_ERROR_EX_TPM_NO_SUCH_COMMAND,


 VB2_ERROR_EX_UNIMPLEMENTED,


 VB2_ERROR_EX_AUXFW_PERIPHERAL_BUSY,



 VB2_ERROR_DEPRECATED_EX_SET_VENDOR_DATA,



 VB2_ERROR_DEPRECATED_EX_DIAG_TEST_RUNNING,



 VB2_ERROR_DEPRECATED_EX_DIAG_TEST_UPDATED,



 VB2_ERROR_DEPRECATED_EX_DIAG_TEST_INIT_FAILED,






 VB2_ERROR_LK = 0x100b0000,


 VB2_ERROR_LK_INVALID_KERNEL_FOUND = 0x100b1000,


 VB2_ERROR_LK_NO_KERNEL_FOUND = 0x100b2000,


 VB2_ERROR_LK_NO_DISK_FOUND = 0x100b3000,




 VB2_ERROR_UI = 0x100c0000,


 VB2_ERROR_UI_DISPLAY_INIT = 0x100c0001,


 VB2_ERROR_UI_INVALID_SCREEN = 0x100c0002,



 VB2_ERROR_UI_DRAW_FAILURE = 0x100c0003,


 VB2_ERROR_UI_INVALID_ARCHIVE = 0x100c0004,


 VB2_ERROR_UI_MISSING_IMAGE = 0x100c0005,


 VB2_ERROR_UI_INVALID_LOCALE = 0x100c0006,


 VB2_ERROR_UI_MEMORY_ALLOC = 0x100c0007,


 VB2_ERROR_UI_LOG_INIT = 0x100c0008,




 VB2_ERROR_HOST_BASE = 0x20000000,




 VB2_ERROR_HOST_MISC = VB2_ERROR_HOST_BASE + 0x010000,


 VB2_ERROR_READ_FILE_OPEN,


 VB2_ERROR_READ_FILE_SIZE,


 VB2_ERROR_READ_FILE_ALLOC,


 VB2_ERROR_READ_FILE_DATA,


 VB2_ERROR_WRITE_FILE_OPEN,


 VB2_ERROR_WRITE_FILE_DATA,


 VB2_ERROR_STR_TO_ID,


 VB2_ERROR_FLASHROM,


 VB2_ERROR_CBFSTOOL,




 VB2_ERROR_HOST_KEY = VB2_ERROR_HOST_BASE + 0x020000,


 VB2_ERROR_READ_PEM_ALLOC,


 VB2_ERROR_READ_PEM_FILE_OPEN,


 VB2_ERROR_READ_PEM_RSA,


 VB2_ERROR_PRIVATE_KEY_SET_DESC,


 VB2_ERROR_UNPACK_PRIVATE_KEY_MAGIC,


 VB2_ERROR_UNPACK_PRIVATE_KEY_HEADER,


 VB2_ERROR_UNPACK_PRIVATE_KEY_DATA,


 VB2_ERROR_UNPACK_PRIVATE_KEY_STRUCT_VERSION,


 VB2_ERROR_UNPACK_PRIVATE_KEY_ALLOC,


 VB2_ERROR_UNPACK_PRIVATE_KEY_RSA,


 VB2_ERROR_UNPACK_PRIVATE_KEY_DESC,


 VB2_ERROR_UNPACK_PRIVATE_KEY_HASH,


 VB2_ERROR_PRIVATE_KEY_WRITE_RSA,


 VB2_ERROR_PRIVATE_KEY_WRITE_ALLOC,


 VB2_ERROR_PRIVATE_KEY_WRITE_FILE,


 VB2_ERROR_PRIVATE_KEY_HASH,


 VB2_ERROR_PUBLIC_KEY_ALLOC_SIZE,


 VB2_ERROR_PUBLIC_KEY_ALLOC,


 VB2_ERROR_PUBLIC_KEY_SET_DESC,


 VB2_ERROR_READ_KEYB_DATA,


 VB2_ERROR_READ_KEYB_SIZE,


 VB2_ERROR_READ_KEYB_ALLOC,


 VB2_ERROR_READ_KEYB_UNPACK,


 VB2_ERROR_READ_PACKED_KEY_DATA,


 VB2_ERROR_READ_PACKED_KEY,


 VB2_ERROR_PUBLIC_KEY_PACK_SIZE,


 VB2_ERROR_PUBLIC_KEY_HASH,


 VB2_ERROR_COPY_KEY_SIZE,


 VB2_ERROR_VB1_CRYPTO_ALGORITHM,


 VB2_ERROR_PACKED_KEY_ALLOC,


 VB2_ERROR_PACKED_KEY_COPY,


 VB2_ERROR_PACKED_KEY_VERSION,




 VB2_ERROR_HOST_SIG = VB2_ERROR_HOST_BASE + 0x030000,


 VB2_ERROR_DIGEST_INFO,





 VB2_ERROR_SIG_SIZE_FOR_KEY,


 VB2_SIGN_DATA_SIG_SIZE,


 VB2_SIGN_DATA_DIGEST_INFO,


 VB2_SIGN_DATA_DIGEST_SIZE,


 VB2_SIGN_DATA_DIGEST_ALLOC,


 VB2_SIGN_DATA_DIGEST_INIT,


 VB2_SIGN_DATA_DIGEST_EXTEND,


 VB2_SIGN_DATA_DIGEST_FINALIZE,


 VB2_SIGN_DATA_RSA_ENCRYPT,


 VB2_SIGN_OBJECT_OVERFLOW,




 VB2_ERROR_HOST_KEYBLOCK = VB2_ERROR_HOST_BASE + 0x040000,


 VB2_KEYBLOCK_CREATE_SIG_SIZE,


 VB2_KEYBLOCK_CREATE_DATA_KEY,


 VB2_KEYBLOCK_CREATE_ALLOC,


 VB2_KEYBLOCK_CREATE_SIGN,




 VB2_ERROR_HOST_FW_PREAMBLE = VB2_ERROR_HOST_BASE + 0x050000,


 VB2_FW_PREAMBLE_CREATE_SIG_SIZE,


 VB2_FW_PREAMBLE_CREATE_ALLOC,


 VB2_FW_PREAMBLE_CREATE_SIGN,




 VB2_ERROR_UNIT_TEST = VB2_ERROR_HOST_BASE + 0x060000,


 VB2_ERROR_TEST_INPUT_FILE,






 VB2_ERROR_MAX = VB2_ERROR_BASE + 0x1fffffff,
};
# 16 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h" 2
# 43 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
struct vb2_sha1_context {
 uint32_t count;
 uint32_t state[5];






 uint8_t buf[64];

};





struct vb2_sha256_context {
 uint32_t h[8];
 uint32_t total_size;
 uint32_t size;
 uint8_t block[2 * 64];
};





struct vb2_sha512_context {
 uint64_t h[8];
 uint32_t total_size;
 uint32_t size;
 uint8_t block[2 * 128];
};
# 88 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
struct vb2_digest_context {

 union {

  struct vb2_sha1_context sha1;


  struct vb2_sha256_context sha256;


  struct vb2_sha512_context sha512;

 };


 enum vb2_hash_algorithm hash_alg;


 bool using_hwcrypto;
};
# 117 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
struct vb2_hash {


 uint8_t reserved[3];

 uint8_t algo;

 union {
  uint8_t raw[0];

  uint8_t sha1[20];


  uint8_t sha256[32];


  uint8_t sha512[64];

 };
};
_Static_assert(sizeof(struct vb2_hash) - __builtin_offsetof(struct vb2_hash, raw)
 <= 64, "Update VB2_MAX_DIGEST_SIZE for new digests!");
_Static_assert(VB2_HASH_ALG_COUNT <= ((uint8_t)0xFF), "vb2_hash.algo overflow!");







void vb2_sha1_init(struct vb2_sha1_context *ctx);
void vb2_sha256_init(struct vb2_sha256_context *ctx,
       enum vb2_hash_algorithm algo);
void vb2_sha512_init(struct vb2_sha512_context *ctx,
       enum vb2_hash_algorithm algo);
# 160 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
void vb2_sha1_update(struct vb2_sha1_context *ctx,
       const uint8_t *data,
       uint32_t size);
void vb2_sha256_update(struct vb2_sha256_context *ctx,
         const uint8_t *data,
         uint32_t size);
void vb2_sha512_update(struct vb2_sha512_context *ctx,
         const uint8_t *data,
         uint32_t size);
# 177 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
void vb2_sha1_finalize(struct vb2_sha1_context *ctx, uint8_t *digest);
void vb2_sha256_finalize(struct vb2_sha256_context *ctx, uint8_t *digest,
    enum vb2_hash_algorithm algo);
void vb2_sha512_finalize(struct vb2_sha512_context *ctx, uint8_t *digest,
    enum vb2_hash_algorithm algo);
# 190 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
void vb2_sha256_extend(const uint8_t *from, const uint8_t *by, uint8_t *to);







size_t vb2_digest_size(enum vb2_hash_algorithm hash_alg);







size_t vb2_hash_block_size(enum vb2_hash_algorithm alg);
# 219 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
vb2_error_t vb2_digest_init(struct vb2_digest_context *dc, bool allow_hwcrypto,
       enum vb2_hash_algorithm algo, uint32_t data_size);
# 230 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
vb2_error_t vb2_digest_extend(struct vb2_digest_context *dc, const uint8_t *buf,
         uint32_t size);
# 243 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
vb2_error_t vb2_digest_finalize(struct vb2_digest_context *dc,
    uint8_t *digest, uint32_t digest_size);
# 256 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
vb2_error_t vb2_hash_calculate(bool allow_hwcrypto, const void *buf,
          uint32_t size, enum vb2_hash_algorithm algo,
          struct vb2_hash *hash);
# 270 "3rdparty/vboot/firmware/include/../2lib/include/2sha.h"
vb2_error_t vb2_hash_verify(bool allow_hwcrypto, const void *buf, uint32_t size,
       const struct vb2_hash *hash);
# 12 "3rdparty/vboot/firmware/include/vb2_sha.h" 2
# 8 "src/commonlib/bsd/include/commonlib/bsd/cbfs_serialized.h" 2

enum cbfs_compression {
 CBFS_COMPRESS_NONE = 0,
 CBFS_COMPRESS_LZMA = 1,
 CBFS_COMPRESS_LZ4 = 2,
};

enum cbfs_type {


 CBFS_TYPE_QUERY = 0,
 CBFS_TYPE_DELETED = 0x00000000,
 CBFS_TYPE_NULL = 0xffffffff,
 CBFS_TYPE_BOOTBLOCK = 0x01,
 CBFS_TYPE_CBFSHEADER = 0x02,
 CBFS_TYPE_LEGACY_STAGE = 0x10,
 CBFS_TYPE_STAGE = 0x11,
 CBFS_TYPE_SELF = 0x20,
 CBFS_TYPE_FIT_PAYLOAD = 0x21,
 CBFS_TYPE_OPTIONROM = 0x30,
 CBFS_TYPE_BOOTSPLASH = 0x40,
 CBFS_TYPE_RAW = 0x50,
 CBFS_TYPE_VSA = 0x51,
 CBFS_TYPE_MBI = 0x52,
 CBFS_TYPE_MICROCODE = 0x53,
 CBFS_TYPE_INTEL_FIT = 0x54,
 CBFS_TYPE_FSP = 0x60,
 CBFS_TYPE_MRC = 0x61,
 CBFS_TYPE_MMA = 0x62,
 CBFS_TYPE_EFI = 0x63,
 CBFS_TYPE_STRUCT = 0x70,
 CBFS_TYPE_AMDFW = 0x80,
 CBFS_TYPE_CMOS_DEFAULT = 0xaa,
 CBFS_TYPE_SPD = 0xab,
 CBFS_TYPE_MRC_CACHE = 0xac,
 CBFS_TYPE_CMOS_LAYOUT = 0x01aa,
};
# 55 "src/commonlib/bsd/include/commonlib/bsd/cbfs_serialized.h"
struct cbfs_header {
 uint32_t magic;
 uint32_t version;
 uint32_t romsize;
 uint32_t bootblocksize;
 uint32_t align;
 uint32_t offset;
 uint32_t architecture;
 uint32_t pad[1];
} __attribute__((__packed__));







enum cbfs_architecture {
 CBFS_ARCHITECTURE_UNKNOWN = 0xFFFFFFFF,
 CBFS_ARCHITECTURE_X86 = 0x00000001,
 CBFS_ARCHITECTURE_ARM = 0x00000010,
 CBFS_ARCHITECTURE_AARCH64 = 0x0000aa64,
 CBFS_ARCHITECTURE_MIPS = 0x00000100,
 CBFS_ARCHITECTURE_RISCV = 0xc001d0de,
 CBFS_ARCHITECTURE_PPC64 = 0x407570ff,
};
# 100 "src/commonlib/bsd/include/commonlib/bsd/cbfs_serialized.h"
struct cbfs_file {
 char magic[8];
 uint32_t len;
 uint32_t type;
 uint32_t attributes_offset;
 uint32_t offset;
 char filename[];
} __attribute__((__packed__));
# 116 "src/commonlib/bsd/include/commonlib/bsd/cbfs_serialized.h"
struct cbfs_file_attribute {
 uint32_t tag;

 uint32_t len;
 uint8_t data[];
} __attribute__((__packed__));






enum cbfs_file_attr_tag {
 CBFS_FILE_ATTR_TAG_UNUSED = 0,
 CBFS_FILE_ATTR_TAG_UNUSED2 = 0xffffffff,
 CBFS_FILE_ATTR_TAG_COMPRESSION = 0x42435a4c,
 CBFS_FILE_ATTR_TAG_HASH = 0x68736148,
 CBFS_FILE_ATTR_TAG_POSITION = 0x42435350,
 CBFS_FILE_ATTR_TAG_ALIGNMENT = 0x42434c41,
 CBFS_FILE_ATTR_TAG_IBB = 0x32494242,
 CBFS_FILE_ATTR_TAG_PADDING = 0x47444150,
 CBFS_FILE_ATTR_TAG_STAGEHEADER = 0x53746748,
};

struct cbfs_file_attr_compression {
 uint32_t tag;
 uint32_t len;

 uint32_t compression;
 uint32_t decompressed_size;
} __attribute__((__packed__));


struct cbfs_file_attr_hash {
 uint32_t tag;
 uint32_t len;
 struct vb2_hash hash;
} __attribute__((__packed__));

struct cbfs_file_attr_position {
 uint32_t tag;
 uint32_t len;
 uint32_t position;
} __attribute__((__packed__));

struct cbfs_file_attr_align {
 uint32_t tag;
 uint32_t len;
 uint32_t alignment;
} __attribute__((__packed__));

struct cbfs_file_attr_stageheader {
 uint32_t tag;
 uint32_t len;
 uint64_t loadaddr;
 uint32_t entry_offset;
 uint32_t memlen;
} __attribute__((__packed__));
# 184 "src/commonlib/bsd/include/commonlib/bsd/cbfs_serialized.h"
struct cbfs_payload_segment {
 uint32_t type;
 uint32_t compression;
 uint32_t offset;
 uint64_t load_addr;
 uint32_t len;
 uint32_t mem_len;
} __attribute__((__packed__));

struct cbfs_payload {
 struct cbfs_payload_segment segments;
};

enum cbfs_payload_segment_type {
 PAYLOAD_SEGMENT_CODE = 0x434F4445,
 PAYLOAD_SEGMENT_DATA = 0x44415441,
 PAYLOAD_SEGMENT_BSS = 0x42535320,
 PAYLOAD_SEGMENT_ENTRY = 0x454E5452,


 PAYLOAD_SEGMENT_DEPRECATED_PARAMS = 0x50415241,
};

struct cbfs_optionrom {
 uint32_t compression;
 uint32_t len;
} __attribute__((__packed__));
# 7 "src/include/program_loading.h" 2
# 1 "src/commonlib/include/commonlib/region.h" 1





# 1 "src/include/sys/types.h" 1
# 7 "src/commonlib/include/commonlib/region.h" 2



# 1 "src/commonlib/include/commonlib/mem_pool.h" 1





# 1 "src/include/assert.h" 1





# 1 "src/arch/riscv/include/arch/hlt.h" 1





static inline __attribute__((__always_inline__)) void hlt(void)
{
 while (1);
}
# 7 "src/include/assert.h" 2
# 33 "src/include/assert.h"
void mock_assert(const int result, const char *const expression,
  const char *const file, const int line);
# 99 "src/include/assert.h"
void _dead_code_assertion_failed(void) __attribute__((noreturn));
# 7 "src/commonlib/include/commonlib/mem_pool.h" 2
# 23 "src/commonlib/include/commonlib/mem_pool.h"
struct mem_pool {
 uint8_t *buf;
 size_t size;
 size_t alignment;
 uint8_t *last_alloc;
 uint8_t *second_to_last_alloc;
 size_t free_offset;
};
# 42 "src/commonlib/include/commonlib/mem_pool.h"
static inline void mem_pool_reset(struct mem_pool *mp)
{
 mp->last_alloc = ((void *)0);
 mp->second_to_last_alloc = ((void *)0);
 mp->free_offset = 0;
}


static inline void mem_pool_init(struct mem_pool *mp, void *buf, size_t sz,
      size_t alignment)
{
 { if (!(__builtin_constant_p(alignment) ? ((alignment) ? 1 : ({ _dead_code_assertion_failed(); *(int *)(uintptr_t)0; })) : 0) && !(alignment)) { printk(0, "ASSERTION ERROR: file '%s', line %d\n", "(filenames not available on timeless builds)", 404); ; if (1) hlt(); } };
 { if (!(__builtin_constant_p((uintptr_t)buf % alignment == 0) ? (((uintptr_t)buf % alignment == 0) ? 1 : ({ _dead_code_assertion_failed(); *(int *)(uintptr_t)0; })) : 0) && !((uintptr_t)buf % alignment == 0)) { printk(0, "ASSERTION ERROR: file '%s', line %d\n", "(filenames not available on timeless builds)", 404); ; if (1) hlt(); } };

 mp->buf = buf;
 mp->size = sz;
 mp->alignment = alignment;
 mem_pool_reset(mp);
}


void *mem_pool_alloc(struct mem_pool *mp, size_t sz);


void mem_pool_free(struct mem_pool *mp, void *alloc);
# 11 "src/commonlib/include/commonlib/region.h" 2
# 21 "src/commonlib/include/commonlib/region.h"
struct region_device;





void *rdev_mmap(const struct region_device *rd, size_t offset, size_t size);


int rdev_munmap(const struct region_device *rd, void *mapping);





ssize_t rdev_readat(const struct region_device *rd, void *b, size_t offset,
   size_t size);





ssize_t rdev_writeat(const struct region_device *rd, const void *b,
   size_t offset, size_t size);






ssize_t rdev_eraseat(const struct region_device *rd, size_t offset,
   size_t size);
# 63 "src/commonlib/include/commonlib/region.h"
int rdev_chain(struct region_device *child, const struct region_device *parent,
  size_t offset, size_t size);


struct region_device_ops {
 void *(*mmap)(const struct region_device *, size_t, size_t);
 int (*munmap)(const struct region_device *, void *);
 ssize_t (*readat)(const struct region_device *, void *, size_t, size_t);
 ssize_t (*writeat)(const struct region_device *, const void *, size_t,
  size_t);
 ssize_t (*eraseat)(const struct region_device *, size_t, size_t);
};

struct region {
 size_t offset;
 size_t size;
};

struct region_device {
 const struct region_device *root;
 const struct region_device_ops *ops;
 struct region region;
};
# 98 "src/commonlib/include/commonlib/region.h"
void region_device_init(struct region_device *rdev,
   const struct region_device_ops *ops, size_t offset,
   size_t size);


int region_is_subregion(const struct region *p, const struct region *c);

static inline size_t region_offset(const struct region *r)
{
 return r->offset;
}

static inline size_t region_sz(const struct region *r)
{
 return r->size;
}

static inline size_t region_end(const struct region *r)
{
 return region_offset(r) + region_sz(r);
}

static inline bool region_overlap(const struct region *r1, const struct region *r2)
{
 return (region_end(r1) > region_offset(r2)) &&
        (region_offset(r1) < region_end(r2));
}

static inline const struct region *region_device_region(
     const struct region_device *rdev)
{
 return &rdev->region;
}

static inline size_t region_device_sz(const struct region_device *rdev)
{
 return region_sz(region_device_region(rdev));
}

static inline size_t region_device_offset(const struct region_device *rdev)
{
 return region_offset(region_device_region(rdev));
}

static inline size_t region_device_end(const struct region_device *rdev)
{
 return region_end(region_device_region(rdev));
}


static inline void *rdev_mmap_full(const struct region_device *rd)
{
 return rdev_mmap(rd, 0, region_device_sz(rd));
}

static inline int rdev_chain_full(struct region_device *child,
    const struct region_device *parent)
{

 return rdev_chain(child, parent, 0, region_device_sz(parent));
}







static inline ssize_t rdev_read_full(const struct region_device *rd, void *b)
{
 return rdev_readat(rd, b, 0, region_device_sz(rd));
}





ssize_t rdev_relative_offset(const struct region_device *p,
    const struct region_device *c);


int rdev_chain_mem(struct region_device *child, const void *base, size_t size);
int rdev_chain_mem_rw(struct region_device *child, void *base, size_t size);

struct mem_region_device {
 char *base;
 struct region_device rdev;
};




void mem_region_device_ro_init(struct mem_region_device *mdev, void *base,
    size_t size);

void mem_region_device_rw_init(struct mem_region_device *mdev, void *base,
    size_t size);

extern const struct region_device_ops mem_rdev_ro_ops;

extern const struct region_device_ops mem_rdev_rw_ops;
# 214 "src/commonlib/include/commonlib/region.h"
struct mmap_helper_region_device {
 struct mem_pool *pool;
 struct region_device rdev;
};







void *mmap_helper_rdev_mmap(const struct region_device *, size_t, size_t);
int mmap_helper_rdev_munmap(const struct region_device *, void *);
# 247 "src/commonlib/include/commonlib/region.h"
struct xlate_window {
 const struct region_device *access_dev;
 struct region sub_region;
};

struct xlate_region_device {
 size_t window_count;
 const struct xlate_window *window_arr;
 struct region_device rdev;
};

extern const struct region_device_ops xlate_rdev_ro_ops;

extern const struct region_device_ops xlate_rdev_rw_ops;
# 276 "src/commonlib/include/commonlib/region.h"
void xlate_region_device_ro_init(struct xlate_region_device *xdev,
         size_t window_count, const struct xlate_window *window_arr,
         size_t parent_size);

void xlate_region_device_rw_init(struct xlate_region_device *xdev,
         size_t window_count, const struct xlate_window *window_arr,
         size_t parent_size);

void xlate_window_init(struct xlate_window *window, const struct region_device *access_dev,
         size_t sub_region_offset, size_t sub_region_size);





struct incoherent_rdev {
 struct region_device rdev;
 const struct region_device *read;
 const struct region_device *write;
};
# 305 "src/commonlib/include/commonlib/region.h"
const struct region_device *incoherent_rdev_init(struct incoherent_rdev *irdev,
    const struct region *r,
    const struct region_device *read,
    const struct region_device *write);
# 8 "src/include/program_loading.h" 2


enum {


 SEG_FINAL = 1 << 0,
};

enum prog_type {
 PROG_UNKNOWN,
 PROG_BOOTBLOCK,
 PROG_VERSTAGE,
 PROG_ROMSTAGE,
 PROG_RAMSTAGE,
 PROG_REFCODE,
 PROG_PAYLOAD,
 PROG_BL31,
 PROG_BL32,
 PROG_POSTCAR,
 PROG_OPENSBI,
};
# 37 "src/include/program_loading.h"
void prog_segment_loaded(uintptr_t start, size_t size, int flags);
void platform_segment_loaded(uintptr_t start, size_t size, int flags);
void arch_segment_loaded(uintptr_t start, size_t size, int flags);


struct prog {
 enum prog_type type;
 enum cbfs_type cbfs_type;
 const char *name;
 void *start;
 size_t size;
 void (*entry)(void *);
 void *arg;
};







static inline const char *prog_name(const struct prog *prog)
{
 return prog->name;
}

static inline enum prog_type prog_type(const struct prog *prog)
{
 return prog->type;
}

static inline enum cbfs_type prog_cbfs_type(const struct prog *prog)
{
 return prog->cbfs_type;
}

static inline size_t prog_size(const struct prog *prog)
{
 return prog->size;
}

static inline void *prog_start(const struct prog *prog)
{
 return prog->start;
}

static inline void *prog_entry(const struct prog *prog)
{
 return prog->entry;
}

static inline void *prog_entry_arg(const struct prog *prog)
{
 return prog->arg;
}


static inline void prog_chain_rdev(const struct prog *prog,
       struct region_device *rdev_out)
{
 rdev_chain_mem(rdev_out, prog->start, prog->size);
}

static inline void prog_set_area(struct prog *prog, void *start, size_t size)
{
 prog->start = start;
 prog->size = size;
}

static inline void prog_set_entry(struct prog *prog, void *e, void *arg)
{
 prog->entry = e;
 prog->arg = arg;
}

static inline void prog_set_arg(struct prog *prog, void *arg)
{
 prog->arg = arg;
}





int prog_locate_hook(struct prog *prog);


void prog_run(struct prog *prog);

void arch_prog_run(struct prog *prog);




void platform_prog_run(struct prog *prog);






void run_romstage(void);


enum cb_err legacy_romstage_select_and_load(struct prog *romstage);
# 153 "src/include/program_loading.h"
void preload_ramstage(void);

void __attribute__((__noreturn__)) run_ramstage(void);





int payload_arch_usable_ram_quirk(uint64_t start, uint64_t size);







void payload_preload(void);

void payload_load(void);


void payload_run(void);
# 185 "src/include/program_loading.h"
bool selfload_check(struct prog *payload, enum bootmem_type dest_type);
bool selfload(struct prog *payload);

bool selfload_mapped(struct prog *payload, void *mapping,
       enum bootmem_type dest_type);


void fit_payload(struct prog *payload, void *data);
# 4 "src/arch/riscv/boot.c" 2
# 1 "src/arch/riscv/include/vm.h" 1







# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 9 "src/arch/riscv/include/vm.h" 2




void mstatus_init(void);
# 60 "src/arch/riscv/include/vm.h"
static inline uint8_t mprv_read_u8(uint8_t *p); static inline uint8_t mprv_read_u8(uint8_t *p) { size_t mprv = 0x00020000; uint8_t value; asm ( "csrs		mstatus, %1\n" "lbu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint16_t mprv_read_u16(uint16_t *p); static inline uint16_t mprv_read_u16(uint16_t *p) { size_t mprv = 0x00020000; uint16_t value; asm ( "csrs		mstatus, %1\n" "lhu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint32_t mprv_read_u32(uint32_t *p); static inline uint32_t mprv_read_u32(uint32_t *p) { size_t mprv = 0x00020000; uint32_t value; asm ( "csrs		mstatus, %1\n" "lwu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint64_t mprv_read_u64(uint64_t *p); static inline uint64_t mprv_read_u64(uint64_t *p) { size_t mprv = 0x00020000; uint64_t value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline long mprv_read_long(long *p); static inline long mprv_read_long(long *p) { size_t mprv = 0x00020000; long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline unsigned long mprv_read_ulong(unsigned long *p); static inline unsigned long mprv_read_ulong(unsigned long *p) { size_t mprv = 0x00020000; unsigned long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint8_t mprv_read_mxr_u8(uint8_t *p); static inline uint8_t mprv_read_mxr_u8(uint8_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint8_t value; asm ( "csrs		mstatus, %1\n" "lbu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint16_t mprv_read_mxr_u16(uint16_t *p); static inline uint16_t mprv_read_mxr_u16(uint16_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint16_t value; asm ( "csrs		mstatus, %1\n" "lhu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint32_t mprv_read_mxr_u32(uint32_t *p); static inline uint32_t mprv_read_mxr_u32(uint32_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint32_t value; asm ( "csrs		mstatus, %1\n" "lwu" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline uint64_t mprv_read_mxr_u64(uint64_t *p); static inline uint64_t mprv_read_mxr_u64(uint64_t *p) { size_t mprv = 0x00020000 | 0x00080000; uint64_t value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline long mprv_read_mxr_long(long *p); static inline long mprv_read_mxr_long(long *p) { size_t mprv = 0x00020000 | 0x00080000; long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline unsigned long mprv_read_mxr_ulong(unsigned long *p); static inline unsigned long mprv_read_mxr_ulong(unsigned long *p) { size_t mprv = 0x00020000 | 0x00080000; unsigned long value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
static inline void mprv_write_u8(uint8_t *p, uint8_t value); static inline void mprv_write_u8(uint8_t *p, uint8_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sb" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_u16(uint16_t *p, uint16_t value); static inline void mprv_write_u16(uint16_t *p, uint16_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sh" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_u32(uint32_t *p, uint32_t value); static inline void mprv_write_u32(uint32_t *p, uint32_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sw" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_u64(uint64_t *p, uint64_t value); static inline void mprv_write_u64(uint64_t *p, uint64_t value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sd" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_long(long *p, long value); static inline void mprv_write_long(long *p, long value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sd" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }
static inline void mprv_write_ulong(unsigned long *p, unsigned long value); static inline void mprv_write_ulong(unsigned long *p, unsigned long value) { size_t mprv = 0x00020000; asm ( "csrs		mstatus, %0\n" "sd" " %1, 0(%2)\n" "csrc		mstatus, %0\n" :: "r"(mprv), "r"(value), "r"(p) : "memory" ); }





 static inline uintptr_t mprv_read_uintptr_t(uintptr_t *p); static inline uintptr_t mprv_read_uintptr_t(uintptr_t *p) { size_t mprv = 0x00020000; uintptr_t value; asm ( "csrs		mstatus, %1\n" "ld" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
 static inline uintptr_t mprv_write_uintptr_t(uintptr_t *p); static inline uintptr_t mprv_write_uintptr_t(uintptr_t *p) { size_t mprv = 0x00020000; uintptr_t value; asm ( "csrs		mstatus, %1\n" "sd" " %0, 0(%2)\n" "csrc		mstatus, %1\n" : "=&r"(value) : "r"(mprv), "r"(p) : "memory" ); return value; }
# 5 "src/arch/riscv/boot.c" 2
# 1 "src/arch/riscv/include/arch/boot.h" 1
# 10 "src/arch/riscv/include/arch/boot.h"
struct prog;
void run_payload(struct prog *prog, void *fdt, int payload_mode);
void run_payload_opensbi(struct prog *prog, void *fdt, struct prog *opensbi, int payload_mode);

void run_opensbi(const int hart_id,
   const void *opensbi,
   const void *fdt,
   const void *payload,
   const int payload_mode);
# 6 "src/arch/riscv/boot.c" 2
# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 7 "src/arch/riscv/boot.c" 2
# 1 "src/arch/riscv/include/arch/smp/smp.h" 1
# 11 "src/arch/riscv/include/arch/smp/smp.h"
void smp_pause(int working_hartid);






void smp_resume(void (*fn)(void *), void *arg);
# 8 "src/arch/riscv/boot.c" 2
# 1 "src/arch/riscv/include/mcall.h" 1
# 21 "src/arch/riscv/include/mcall.h"
# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 22 "src/arch/riscv/include/mcall.h" 2
# 1 "src/arch/riscv/include/arch/smp/atomic.h" 1





# 1 "src/arch/riscv/include/arch/encoding.h" 1
# 7 "src/arch/riscv/include/arch/smp/atomic.h" 2

typedef struct { volatile int counter; } atomic_t;
# 24 "src/arch/riscv/include/arch/smp/atomic.h"
static inline int atomic_add(atomic_t *v, int inc)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter += inc;
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_swap(atomic_t *v, int swp)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter = swp;
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_cas(atomic_t *v, int cmp, int swp)
{
 long flags = ({ unsigned long __tmp; asm volatile ("csrrc %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"(0x00000008)); __tmp; });
 int res = v->counter;
 v->counter = (res == cmp ? swp : res);
 ({ unsigned long __tmp; asm volatile ("csrrs %0, " "mstatus" ", %1" : "=r"(__tmp) : "rK"((flags) & 0x00000008)); __tmp; });
 return res;
}

static inline int atomic_inc(atomic_t *v)
{
 return atomic_add(v, 1);
}

static inline int atomic_dec(atomic_t *v)
{
 return atomic_add(v, -1);
}
# 23 "src/arch/riscv/include/mcall.h" 2


struct sbi_device_message {
 unsigned long dev;
 unsigned long cmd;
 unsigned long data;
 unsigned long sbi_private_data;
};

struct blocker {
 void *arg;
 void (*fn)(void *arg);
 atomic_t sync_a;
 atomic_t sync_b;
};

struct hls {
 struct sbi_device_message *device_request_queue_head;
 unsigned long device_request_queue_size;
 struct sbi_device_message *device_response_queue_head;
 struct sbi_device_message *device_response_queue_tail;

 int hart_id;
 int ipi_pending;
 uint64_t *timecmp;
 uint64_t *time;
 void *fdt;
 struct blocker entry;
};

_Static_assert(
 sizeof(struct hls) == 88,
 "HLS_SIZE must equal to sizeof(struct hls)");

register uintptr_t current_stack_pointer asm("sp");
# 69 "src/arch/riscv/include/mcall.h"
void hls_init(uint32_t hart_id, void *fdt);


void mtime_init(void);
# 81 "src/arch/riscv/include/mcall.h"
void set_msip(int hartid, int val);
# 9 "src/arch/riscv/boot.c" 2
# 1 "src/include/cbfs.h" 1





# 1 "src/include/cbmem.h" 1





# 1 "src/commonlib/bsd/include/commonlib/bsd/cbmem_id.h" 1
# 7 "src/include/cbmem.h" 2






struct cbmem_entry;
# 38 "src/include/cbmem.h"
static inline size_t cbmem_overhead_size(void)
{
 return 2 * (4096);
}



int cbmem_initialize(void);
int cbmem_initialize_id_size(u32 id, u64 size);


void cbmem_initialize_empty(void);
void cbmem_initialize_empty_id_size(u32 id, u64 size);
# 59 "src/include/cbmem.h"
extern uintptr_t _cbmem_top_ptr;
void *cbmem_top(void);







uintptr_t cbmem_top_chipset(void);




const struct cbmem_entry *cbmem_entry_add(u32 id, u64 size);


const struct cbmem_entry *cbmem_entry_find(u32 id);




int cbmem_entry_remove(const struct cbmem_entry *entry);


void *cbmem_entry_start(const struct cbmem_entry *entry);
u64 cbmem_entry_size(const struct cbmem_entry *entry);



int cbmem_recovery(int s3resume);



void *cbmem_add(u32 id, u64 size);

void *cbmem_find(u32 id);


typedef void (* const cbmem_init_hook_t)(int is_recovery);
void cbmem_run_init_hooks(int is_recovery);



void cbmem_add_bootmem(void);

void cbmem_get_region(void **baseptr, size_t *size);
void cbmem_list(void);
void cbmem_add_records_to_cbtable(struct lb_header *header);
# 140 "src/include/cbmem.h"
static inline int cbmem_online(void)
{
 extern int cbmem_initialized;

 if (!((0 || (0 && !1)) || 0 || 1))
  return 0;

 return cbmem_initialized;
}
# 7 "src/include/cbfs.h" 2
# 1 "src/commonlib/bsd/include/commonlib/bsd/cbfs_mdata.h" 1
# 20 "src/commonlib/bsd/include/commonlib/bsd/cbfs_mdata.h"
union cbfs_mdata {
 struct cbfs_file h;
 uint8_t raw[256];
};




const void *cbfs_find_attr(const union cbfs_mdata *mdata, uint32_t attr_tag, size_t size_check);


const struct vb2_hash *cbfs_file_hash(const union cbfs_mdata *mdata);
# 8 "src/include/cbfs.h" 2


# 1 "src/include/endian.h" 1





# 1 "src/arch/riscv/include/arch/byteorder.h" 1
# 7 "src/include/endian.h" 2

# 1 "src/include/swab.h" 1
# 9 "src/include/endian.h" 2
# 76 "src/include/endian.h"
static inline uint16_t be16dec(const void *p) { return ((uint16_t)__builtin_bswap16(*(uint16_t *)p)); }
static inline uint32_t be32dec(const void *p) { return ((uint32_t)__builtin_bswap32(*(uint32_t *)p)); }
static inline uint64_t be64dec(const void *p) { return ((uint64_t)__builtin_bswap64(*(uint64_t *)p)); }
static inline uint16_t le16dec(const void *p) { return ((uint16_t)(*(uint16_t *)p)); }
static inline uint32_t le32dec(const void *p) { return ((uint32_t)(*(uint32_t *)p)); }
static inline uint64_t le64dec(const void *p) { return ((uint64_t)(*(uint64_t *)p)); }







static inline void be16enc(void *p, uint16_t u) { *(uint16_t *)p = ((uint16_t)__builtin_bswap16(u)); }
static inline void be32enc(void *p, uint32_t u) { *(uint32_t *)p = ((uint32_t)__builtin_bswap32(u)); }
static inline void be64enc(void *p, uint64_t u) { *(uint64_t *)p = ((uint64_t)__builtin_bswap64(u)); }
static inline void le16enc(void *p, uint16_t u) { *(uint16_t *)p = ((uint16_t)(u)); }
static inline void le32enc(void *p, uint32_t u) { *(uint32_t *)p = ((uint32_t)(u)); }
static inline void le64enc(void *p, uint64_t u) { *(uint64_t *)p = ((uint64_t)(u)); }





static inline uint16_t htobe16(uint16_t host_16bits)
{
 return ((uint16_t)__builtin_bswap16(host_16bits));
}

static inline uint16_t htole16(uint16_t host_16bits)
{
 return ((uint16_t)(host_16bits));
}

static inline uint16_t be16toh(uint16_t big_endian_16bits)
{
 return ((uint16_t)__builtin_bswap16(big_endian_16bits));
}

static inline uint16_t le16toh(uint16_t little_endian_16bits)
{
 return ((uint16_t)(little_endian_16bits));
}

static inline uint32_t htobe32(uint32_t host_32bits)
{
 return ((uint32_t)__builtin_bswap32(host_32bits));
}

static inline uint32_t htole32(uint32_t host_32bits)
{
 return ((uint32_t)(host_32bits));
}

static inline uint32_t be32toh(uint32_t big_endian_32bits)
{
 return ((uint32_t)__builtin_bswap32(big_endian_32bits));
}

static inline uint32_t le32toh(uint32_t little_endian_32bits)
{
 return ((uint32_t)(little_endian_32bits));
}

static inline uint64_t htobe64(uint64_t host_64bits)
{
 return ((uint64_t)__builtin_bswap64(host_64bits));
}

static inline uint64_t htole64(uint64_t host_64bits)
{
 return ((uint64_t)(host_64bits));
}

static inline uint64_t be64toh(uint64_t big_endian_64bits)
{
 return ((uint64_t)__builtin_bswap64(big_endian_64bits));
}

static inline uint64_t le64toh(uint64_t little_endian_64bits)
{
 return ((uint64_t)(little_endian_64bits));
}
# 11 "src/include/cbfs.h" 2
# 76 "src/include/cbfs.h"
typedef void *(*cbfs_allocator_t)(void *arg, size_t size, const union cbfs_mdata *mdata);

static inline size_t cbfs_load(const char *name, void *buf, size_t size);
static inline size_t cbfs_ro_load(const char *name, void *buf, size_t size);
static inline size_t cbfs_type_load(const char *name, void *buf, size_t size,
        enum cbfs_type *type);
static inline size_t cbfs_ro_type_load(const char *name, void *buf, size_t size,
        enum cbfs_type *type);
static inline size_t cbfs_unverified_area_load(const char *area, const char *name,
            void *buf, size_t size);

static inline void *cbfs_map(const char *name, size_t *size_out);
static inline void *cbfs_ro_map(const char *name, size_t *size_out);
static inline void *cbfs_type_map(const char *name, size_t *size_out, enum cbfs_type *type);
static inline void *cbfs_ro_type_map(const char *name, size_t *size_out, enum cbfs_type *type);
static inline void *cbfs_unverified_area_map(const char *area, const char *name,
           size_t *size_out);

static inline void *cbfs_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
          size_t *size_out);
static inline void *cbfs_ro_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
      size_t *size_out);
static inline void *cbfs_type_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
        size_t *size_out, enum cbfs_type *type);
static inline void *cbfs_ro_type_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
           size_t *size_out, enum cbfs_type *type);
static inline void *cbfs_unverified_area_alloc(const char *area, const char *name,
      cbfs_allocator_t allocator, void *arg,
      size_t *size_out);

static inline void *cbfs_cbmem_alloc(const char *name, uint32_t cbmem_id, size_t *size_out);
static inline void *cbfs_ro_cbmem_alloc(const char *name, uint32_t cbmem_id, size_t *size_out);
static inline void *cbfs_type_cbmem_alloc(const char *name, uint32_t cbmem_id, size_t *size_out,
       enum cbfs_type *type);
static inline void *cbfs_ro_type_cbmem_alloc(const char *name, uint32_t cbmem_id,
          size_t *size_out, enum cbfs_type *type);
static inline void *cbfs_unverified_area_cbmem_alloc(const char *area, const char *name,
            uint32_t cbmem_id, size_t *size_out);
# 128 "src/include/cbfs.h"
void cbfs_preload(const char *name);



void cbfs_unmap(void *mapping);


enum cb_err cbfs_prog_stage_load(struct prog *prog);



static inline size_t cbfs_get_size(const char *name);
static inline size_t cbfs_ro_get_size(const char *name);



static inline enum cbfs_type cbfs_get_type(const char *name);
static inline enum cbfs_type cbfs_ro_get_type(const char *name);


static inline bool cbfs_file_exists(const char *name);
static inline bool cbfs_ro_file_exists(const char *name);
# 159 "src/include/cbfs.h"
extern struct mem_pool cbfs_cache;






struct cbfs_boot_device {
 struct region_device rdev;
 void *mcache;
 size_t mcache_size;
};


void cbfs_boot_device_find_mcache(struct cbfs_boot_device *cbd, uint32_t id);






const struct cbfs_boot_device *cbfs_get_boot_device(bool force_ro);







enum cb_err cbfs_init_boot_device(const struct cbfs_boot_device *cbd,
      struct vb2_hash *metadata_hash);





enum cb_err _cbfs_boot_lookup(const char *name, bool force_ro,
         union cbfs_mdata *mdata, struct region_device *rdev);

void *_cbfs_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
    size_t *size_out, bool force_ro, enum cbfs_type *type);

void *_cbfs_unverified_area_alloc(const char *area, const char *name,
      cbfs_allocator_t allocator, void *arg, size_t *size_out);

struct _cbfs_default_allocator_arg {
 void *buf;
 size_t buf_size;
};
void *_cbfs_default_allocator(void *arg, size_t size, const union cbfs_mdata *unused);

void *_cbfs_cbmem_allocator(void *arg, size_t size, const union cbfs_mdata *unused);




static inline void *cbfs_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
          size_t *size_out)
{
 return cbfs_type_alloc(name, allocator, arg, size_out, ((void *)0));
}

static inline void *cbfs_ro_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
      size_t *size_out)
{
 return cbfs_ro_type_alloc(name, allocator, arg, size_out, ((void *)0));
}

static inline void *cbfs_type_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
        size_t *size_out, enum cbfs_type *type)
{
 return _cbfs_alloc(name, allocator, arg, size_out, 0, type);
}

static inline void *cbfs_ro_type_alloc(const char *name, cbfs_allocator_t allocator, void *arg,
           size_t *size_out, enum cbfs_type *type)
{
 return _cbfs_alloc(name, allocator, arg, size_out, 1, type);
}

static inline void *cbfs_unverified_area_alloc(const char *area, const char *name,
            cbfs_allocator_t allocator, void *arg,
            size_t *size_out)
{
 return _cbfs_unverified_area_alloc(area, name, allocator, arg, size_out);
}

static inline void *cbfs_map(const char *name, size_t *size_out)
{
 return cbfs_type_map(name, size_out, ((void *)0));
}

static inline void *cbfs_ro_map(const char *name, size_t *size_out)
{
 return cbfs_ro_type_map(name, size_out, ((void *)0));
}

static inline void *cbfs_type_map(const char *name, size_t *size_out, enum cbfs_type *type)
{
 return cbfs_type_alloc(name, ((void *)0), ((void *)0), size_out, type);
}

static inline void *cbfs_ro_type_map(const char *name, size_t *size_out, enum cbfs_type *type)
{
 return cbfs_ro_type_alloc(name, ((void *)0), ((void *)0), size_out, type);
}

static inline void *cbfs_unverified_area_map(const char *area, const char *name,
          size_t *size_out)
{
 return _cbfs_unverified_area_alloc(area, name, ((void *)0), ((void *)0), size_out);
}

static inline size_t _cbfs_load(const char *name, void *buf, size_t size, bool force_ro,
    enum cbfs_type *type)
{
 struct _cbfs_default_allocator_arg arg = { .buf = buf, .buf_size = size };
 if (_cbfs_alloc(name, _cbfs_default_allocator, &arg, &size, force_ro, type))
  return size;
 else
  return 0;
}

static inline size_t cbfs_load(const char *name, void *buf, size_t size)
{
 return cbfs_type_load(name, buf, size, ((void *)0));
}

static inline size_t cbfs_type_load(const char *name, void *buf, size_t size,
        enum cbfs_type *type)
{
 return _cbfs_load(name, buf, size, 0, type);
}

static inline size_t cbfs_ro_load(const char *name, void *buf, size_t size)
{
 return cbfs_ro_type_load(name, buf, size, ((void *)0));
}

static inline size_t cbfs_ro_type_load(const char *name, void *buf, size_t size,
        enum cbfs_type *type)
{
 return _cbfs_load(name, buf, size, 1, type);
}

static inline size_t cbfs_unverified_area_load(const char *area, const char *name,
            void *buf, size_t size)
{
 struct _cbfs_default_allocator_arg arg = { .buf = buf, .buf_size = size };
 if (_cbfs_unverified_area_alloc(area, name, _cbfs_default_allocator, &arg, &size))
  return size;
 else
  return 0;
}

static inline void *cbfs_cbmem_alloc(const char *name, uint32_t cbmem_id, size_t *size_out)
{
 return cbfs_type_cbmem_alloc(name, cbmem_id, size_out, ((void *)0));
}

static inline void *cbfs_ro_cbmem_alloc(const char *name, uint32_t cbmem_id, size_t *size_out)
{
 return cbfs_ro_type_cbmem_alloc(name, cbmem_id, size_out, ((void *)0));
}

static inline void *cbfs_type_cbmem_alloc(const char *name, uint32_t cbmem_id, size_t *size_out,
       enum cbfs_type *type)
{
 return cbfs_type_alloc(name, _cbfs_cbmem_allocator, (void *)(uintptr_t)cbmem_id,
          size_out, type);
}

static inline void *cbfs_ro_type_cbmem_alloc(const char *name, uint32_t cbmem_id,
          size_t *size_out, enum cbfs_type *type)
{
 return cbfs_ro_type_alloc(name, _cbfs_cbmem_allocator, (void *)(uintptr_t)cbmem_id,
      size_out, type);
}

static inline void *cbfs_unverified_area_cbmem_alloc(const char *area, const char *name,
           uint32_t cbmem_id, size_t *size_out)
{
 return _cbfs_unverified_area_alloc(area, name, _cbfs_cbmem_allocator,
        (void *)(uintptr_t)cbmem_id, size_out);
}

static inline size_t cbfs_get_size(const char *name)
{
 union cbfs_mdata mdata;
 struct region_device rdev;
 if (_cbfs_boot_lookup(name, 0, &mdata, &rdev) != CB_SUCCESS)
  return 0;
 return be32toh(mdata.h.len);
}

static inline size_t cbfs_ro_get_size(const char *name)
{
 union cbfs_mdata mdata;
 struct region_device rdev;
 if (_cbfs_boot_lookup(name, 1, &mdata, &rdev) != CB_SUCCESS)
  return 0;
 return be32toh(mdata.h.len);
}

static inline enum cbfs_type cbfs_get_type(const char *name)
{
 union cbfs_mdata mdata;
 struct region_device rdev;
 if (_cbfs_boot_lookup(name, 0, &mdata, &rdev) != CB_SUCCESS)
  return CBFS_TYPE_NULL;
 return be32toh(mdata.h.type);
}

static inline enum cbfs_type cbfs_ro_get_type(const char *name)
{
 union cbfs_mdata mdata;
 struct region_device rdev;
 if (_cbfs_boot_lookup(name, 1, &mdata, &rdev) != CB_SUCCESS)
  return CBFS_TYPE_NULL;
 return be32toh(mdata.h.type);
}

static inline bool cbfs_file_exists(const char *name)
{
 union cbfs_mdata mdata;
 struct region_device rdev;
 if (_cbfs_boot_lookup(name, 0, &mdata, &rdev) != CB_SUCCESS)
  return 0;
 return 1;
}

static inline bool cbfs_ro_file_exists(const char *name)
{
 union cbfs_mdata mdata;
 struct region_device rdev;
 if (_cbfs_boot_lookup(name, 1, &mdata, &rdev) != CB_SUCCESS)
  return 0;
 return 1;
}
# 10 "src/arch/riscv/boot.c" 2


struct arch_prog_run_args {
 struct prog *prog;
 struct prog *opensbi;
};
# 24 "src/arch/riscv/boot.c"
static void do_arch_prog_run(struct arch_prog_run_args *args)
{
 int hart_id = ((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88))->hart_id;
 struct prog *prog = args->prog;
 void *fdt = ((struct hls *)(({ (void *)((current_stack_pointer + (1 << 12)) & -(1 << 12)); }) - 88))->fdt;

 if (prog_cbfs_type(prog) == CBFS_TYPE_FIT_PAYLOAD)
  fdt = prog_entry_arg(prog);

 if (1 && prog_type(prog) == PROG_PAYLOAD) {
  if (0) {

   run_payload_opensbi(prog, fdt, args->opensbi, 1);
  } else {
   run_payload(prog, fdt, 1);
  }
 } else {
  void (*doit)(int hart_id, void *fdt, void *arg) = prog_entry(prog);
  doit(hart_id, fdt, prog_entry_arg(prog));
 }

 die("Failed to run stage");
}

void arch_prog_run(struct prog *prog)
{
 struct arch_prog_run_args args = {};

 args.prog = prog;


 if (1 && 0) {
  struct prog sbi = { .type = (PROG_OPENSBI), .name = ("fallback""/opensbi"), };

  if (!selfload_check(&sbi, BM_MEM_OPENSBI))
   die("OpenSBI load failed");

  args.opensbi = &sbi;
 }

 smp_resume((void (*)(void *))do_arch_prog_run, &args);
}
